#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum PsdDisplayMode {
    #[serde(rename = "AVERAGE")]
    Average,
    #[serde(rename = "MAX")]
    Max,
    #[serde(rename = "MIN")]
    Min,
    #[serde(rename = "MIN_MAX_ENVELOPE")]
    MinMaxEnvelope,
    #[serde(rename = "NONE")]
    None,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl PsdDisplayMode {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            PsdDisplayMode::Average => "AVERAGE",
            PsdDisplayMode::Max => "MAX",
            PsdDisplayMode::Min => "MIN",
            PsdDisplayMode::MinMaxEnvelope => "MIN_MAX_ENVELOPE",
            PsdDisplayMode::None => "NONE",
            PsdDisplayMode::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for PsdDisplayMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for PsdDisplayMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for PsdDisplayMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<PsdDisplayMode, conjure_object::plain::ParseEnumError> {
        match v {
            "AVERAGE" => Ok(PsdDisplayMode::Average),
            "MAX" => Ok(PsdDisplayMode::Max),
            "MIN" => Ok(PsdDisplayMode::Min),
            "MIN_MAX_ENVELOPE" => Ok(PsdDisplayMode::MinMaxEnvelope),
            "NONE" => Ok(PsdDisplayMode::None),
            v => v.parse().map(|v| PsdDisplayMode::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for PsdDisplayMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<PsdDisplayMode, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the PsdDisplayMode enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
